<template>
  <v-ons-page id="signUp">
    <v-ons-toolbar>
      <div class="center">
        <img src="@/assets/images/logo.svg" alt="J-Class" class="logo" />
      </div>
    </v-ons-toolbar>

    <div id="signUpInner">
      <div class="layout-form">
        <div class="form-group">
          <div class="content">
            <input
              :class="{ 'is-invalid': validation.hasError('email') }"
              type="text"
              placeholder="Masukan Email"
              class="form-control"
              v-model="email"
            />
          </div>
          <small id="emailHelp" class="form-text text-muted"
            ><span :class="{ 'text-danger': validation.hasError('email') }">{{
              validation.firstError("email")
            }}</span></small
          >
        </div>
        <div class="form-group">
          <div class="input-group mb-3">
            <input
              :class="{ 'is-invalid': validation.hasError('password') }"
              :type="passwordInputType"
              placeholder="Masukan Kata sandi"
              class="form-control"
              v-model="password"
            />
            <div class="input-group-prepend">
              <span class="input-group-text" @click="seePasswordClick()"
                ><i
                  :class="seePassword === true ? 'fa-eye-slash' : 'fa-eye'"
                  class="fa"
                  aria-hidden="true"
                ></i
              ></span>
            </div>
          </div>
          <small id="passwordHelp" class="form-text text-muted"
            ><span
              :class="{ 'text-danger': validation.hasError('password') }"
              >{{ validation.firstError("password") }}</span
            ></small
          >
        </div>
        <div class="form-check form-group">
          <input
            type="checkbox"
            class="form-check-input"
            id="exampleCheck1"
            v-model="checkbox"
          />
          <label class="form-check-label" for="exampleCheck1"
            >Otomatis Masuk</label
          >
        </div>
        <div class="form-group">
          <div class="actions text-center">
            <button
              type="button"
              :disabled="!sendingData"
              class="btn btn-primary"
              @click="login()"
            >
              {{ sendingData === false ? "Memuat" : "Masuk" }}
            </button>
          </div>
        </div>
      </div>
    </div>

    <div class="container fixed-bottom">
      <div class="row text-center boxButton">
        <div class="col-lg btn btn-primary" @click="gotoDaftar()">
          Klik Untuk Daftar
        </div>
      </div>
    </div>

    <v-ons-alert-dialog modifier="rowfooter" :visible.sync="errorServer">
      {{ message }}
      <template slot="footer">
        <v-ons-alert-dialog-button @click="errorServer = false"
          >Ok</v-ons-alert-dialog-button
        >
      </template>
    </v-ons-alert-dialog>
  </v-ons-page>
</template>
<script>
import Vue from "vue";
import { Promise } from "q";
import { resolve } from "url";
import authReg from "@/scripts/auth";
import mainMenu from "../MainMenu";
import signUp from "../auth/Registration";

// Documentation, check at http://simple-vue-validator.magictek.cn/

import validatorVue from "simple-vue-validator";
const Validator = validatorVue.Validator;
Vue.use(validatorVue, {
  templates: {
    error: "Kesalahan",
    required: "Kolom ini harus diisi",
    email: "Email salah",
    minLength: "Minimal {0} huruf ditulis.",
  },
});

export default {
  data() {
    return {
      email: "",
      password: "",
      checkbox: false,
      errorServer: false,
      sendingData: true,
      message: "",
      passwordInputType: "password",
      seePassword: true,
    };
  },

  // Documentation, check at http://simple-vue-validator.magictek.cn/
  validators: {
    email: function (value) {
      return Validator.value(value).required().minLength(5).email();
    },
    password: function (value) {
      return Validator.value(value).required().minLength(6);
    },
  },
  methods: {
    gotoDaftar() {
      this.$store.commit("navigator/specialPop", signUp);
    },
    seePasswordClick() {
      this.passwordInputType = this.seePassword === true ? "text" : "password";
      this.seePassword = this.seePassword === true ? false : true;
    },
    login() {
      // memakai that agar this bisa terbaca setelah 'then'
      const that = this;

      this.$validate().then((success) => {
        if (success) {
          that.sendingData = false;
          // output message
          const logIn = Promise.all(
            authReg.LogIn(that.email, that.password, that.checkbox)
          );

          logIn
            .then(function (user) {
              // dispatch user information to state
              that.$store.commit("navigator/specialPop", mainMenu);
            })
            .catch((error) => {
              that.errorServer = true;
              that.message = error;
            })
            .finally(() => {
              that.sendingData = true;
            });
        }
      });
    },
  },
};
</script>